;Flchenermittlung Matz 1996
;letzte Revision 14.04.99

(defun *error* (msg)                       ;Fehler-Routine
     (princ "\nFunktion beendet ")
     (setvar "osmode" ofm)
     (command "_redraw")
     (grtext)
     (princ)
)

(defun c:qm1 (/ ple plv rcode rbez rcodev rbezv
                co ho weit hb pl s stop sstart flaeche
                ofm exit mp ip auswahl asflaeche flaecheg ende)
(setq exit nil
    rcodev ""
     rbezv ""
       plv "N"
)

;Dialoge laden
(if (not flstat)(load"flstat"))
;Flchenberechnung beginnen
(while (not exit)
(flstat)
(if exit (exit)) ;Programm beenden
(setq     ende nil
      flaecheg 0.0
       flaeche 0.0
            th (getvar "Textsize")
            la (getvar "CLAYER")
            co 6
           ofm (getvar "osmode")
)
(defun grbox () ;Startpunkt zeichnen
 (grdraw sstart (polar sstart (* pi 0.25) hb) co)
 (grdraw sstart (polar sstart (* pi 1.25) hb) co)
 (grdraw sstart (polar sstart (* pi 0.75) hb) co)  ;tb statt hb
 (grdraw sstart (polar sstart (* pi 1.75) hb) co)  ;tb statt hb
)

(defun laykont () ;Layer Kontur erzeugen oder setzen  (falls gefroren)
(if (tblsearch "LAYER" "AK_FLAECHE")
 (if (not (zerop (logand (cdr (assoc 70 (tblsearch "LAYER" "AK_FLAECHE"))) 1)))
 (progn
  (command "_Layer" "_T" "AK_FLAECHE" "")
  (command "_Layer" "_S" "AK_FLAECHE" "")
 );end progn
  (command "_Layer" "_S" "AK_FLAECHE" "")
 );end if
  (command "_Layer" "_M" "AK_FLAECHE" "_S" "AK_FLAECHE" "")
);end if
)
; Teilflchen ermitteln (addieren;subtrahieren)
(defun qm ()
(setq stop nil
        ho (getvar "viewsize") ra (getvar "screensize")
      weit (* ho (/ (car ra) (cadr ra)))
        hb (/ ho 65.00)
    pliste nil
        pl 0
         s T
)
(menucmd "S=X") (menucmd "S=QM1")
(grtext -1 (strcat (rtos flaecheg 2 rf) "m[2") 1)
(flstat2); Dialog 2
(cond
((= art "F")
(setq s (getpoint "\nErster Punkt: "))
(while (boundp 's)
(if (= pl 0)
 (setq sstart s)
 (progn
  (grbox)
  (setq s (getpoint "\nnchster Punkt: (RETURN = schliessen) " pl))
 );end progn
);end if
(setvar "osmode" 0)
(if (= pl 0)
(cond
((= 'LIST (Type s))
 (setq pliste (append pliste (list s)))
 (grbox)
 (setq pl s sv s)
));endcond
(cond
((= 'LIST (Type s))
 (setq pliste (append pliste (list s)))
 (grdraw sv s co)
 (grtext -1 (rtos (distance sv s) 2 rf) 1)
 (setq pl s sv s)
)); endcond
);endif
(setvar "osmode" ofm)

);endwhile
(cond
((= 'LIST (Type s))
(setq pliste (append pliste (list sstart)))
));endcond
(grdraw sv sstart co)
(setq zz 0)
(if (boundp 'pliste)
(progn
 (command "_area")
  (while (< zz (length pliste))
   (setq mt (list (nth zz pliste))
          m (list (car (nth 0 mt)) (cadr (nth 0 mt)))
   )
   (command "_none" m)
   (setq zz (1+ zz))
  ); endwhile
 (command "")
);endprogn
);if
(princ (strcat "\nPolylinie erstellen <" plv "> (J/N) "))
(setq ple (strcase (getstring)))
(if (= ple "")
    (setq ple plv)
    (setq plv ple)
)
(cond
((= ple "J")
(setq lvor (getvar "clayer"))
(laykont)
(setq zz 0)
(if (boundp 'pliste)
(progn
 (command "_pline" )
  (while (< zz (length pliste))
   (setq mt (list (nth zz pliste))
          m (list (car (nth 0 mt)) (cadr (nth 0 mt)))
   )
   (command "_none" m)
   (setq zz (1+ zz))
  ); endwhile
 (command "_C")
);end "J"
);end cond
(setvar "clayer" lvor)
);end progn
);end if pline
);end cond erster Punkt

((= art "O")
 (setq ent (entsel "\nBitte Polylinie oder Kreis zeigen: "))
 (command "_area" "_E" ent)
);end cond "O"
((= art "P")
(setq lvor (getvar "clayer"))
 (laykont)
(setq ip (getpoint "\nPunkt whlen: "))
(command "_boundary" ip "")
(command "_area" "_E" "_L")
(princ (strcat "\nPolylinie erstellen <" plv "> (J/N) "))
(setq ple (strcase (getstring)))
(if (= ple "")
    (setq ple plv)
    (setq plv ple)
)
(cond
 ((= ple "j")
 (entdel (entlast))
 )
);end cond

(SETVAR "CLAYER" LVOR)
(command "_redraw")
);end "P"
);end cond (Flche / Objekt)

(if (/= art "S")
(progn
 (setq flaeche (getvar "AREA"))
 (grtext -1 (strcat (rtos flaeche 2 rf) "m[2") 1)
 (setq flaeche (* flaeche fak))
);end progn
);end if
(grtext -1 (strcat (rtos flaeche 2 rf) "m[2") 1)
);end qm
(qm)
(setq flaecheg (+ flaecheg flaeche))
(while (not ende)
 (qm)
   (if (/= art "S")
    (flstat3) ;Dialog 3
   )
   (cond
    ((= (strcase auswahl) "A")(setq co 6 as T)(setq flaecheg (+ flaecheg flaeche)))
    ((= (strcase auswahl) "S")(setq co 6 as T)(setq flaecheg (- flaecheg flaeche)))
    ((= (strcase auswahl) "W")(setq co 6 as T))
    ((= (strcase auswahl) "")(setq co 6 ende T))
   );endcond
);end while
(if (= fl "1")
 (setq erm_fl (strcat (rtos flaecheg 2 rf) " m[2"))
 (setq erm_fl "")
)
(menucmd "S=X") (menucmd "S=area1")

(princ (strcat "\nRaumcode: <" rcodev "> (T)ext picken "))
(setq rcode (getstring T))
 (if (= rcode "")
  (setq rcode rcodev)
  (setq rcodev rcode)
 )
 (if (= (strcase rcode) "T")
  (setq rcodev rcode
         rcode (cdr (assoc 1 (entget (car (nentsel "\nText picken: "))))))
 )

(princ (strcat "\nRaumbezeichnung: <" rbezv "> (T)ext picken "))
(setq Rbez (getstring T))
 (if (= rbez "")
  (setq rbez rbezv)
  (setq rbezv rbez)
 )
 (if (= (strcase rbez) "T")
  (setq rbezv rbez
         rbez (cdr (assoc 1 (entget (car (nentsel "\nText picken: "))))))
 )

(if (= uf "1")
  (setq umfang (getvar "perimeter")
        erm_uf (strcat (rtos umfang 2 rf) " m")
  )
 (setq erm_uf "")
);end if

(if (= wf "1")
  (setq umfang (getvar "perimeter")
        erm_wf (strcat (rtos (* umfang rh) 2 rf) " m[2")
  )
 (setq erm_wf "")
);end if

(if (= kb "1")
 (setq erm_kb (strcat (rtos (* flaecheg rh) 2 rf) " m[3"))
 (setq erm_kb "")
);end if

(setq orthom (getvar "orthomode"))
(setvar "orthomode" 0)
(princ "\nEinfgeposition <Unten links> zeigen: ")(princ)
(command "-_insert" "rcode" (setq mp (cadr (grread 1))) (/ (getvar "textsize") 0.0025) "" "" Rcode Rbez erm_fl erm_uf erm_wf erm_kb)
(command "_move" (entlast) "" mp "_none" pause)
(setvar "orthomode" orthom)
);end while exit

(command "_redraw")
(setvar "osmode" ofm)
(grtext)
(princ)
);end program qm1
